Skip to main content

Initializers


scopeRequired

  • Type: constructs.Construct

idRequired

  • Type: str

defaultsOptional

  • Type: typing.Mapping[typing.Any]

workspaceOptional

  • Type: str

bucketRequired

  • Type: str
(Required) The name of the GCS bucket. This name must be globally unique.

access_tokenOptional

  • Type: str
(Optional) A temporary [OAuth 2.0 access token] obtained from the Google Authorization server, i.e. the Authorization: Bearer token used to authenticate HTTP requests to GCP APIs. This is an alternative to credentials. If both are specified, access_token will be used over the credentials field.

credentialsOptional

  • Type: str
(Optional) Local path to Google Cloud Platform account credentials in JSON format. If unset, Google Application Default Credentials are used. The provided credentials must have Storage Object Admin role on the bucket. Warning: if using the Google Cloud Platform provider as well, it will also pick up the GOOGLE_CREDENTIALS environment variable.

encryption_keyOptional

  • Type: str
(Optional) A 32 byte base64 encoded ‘customer supplied encryption key’ used to encrypt all state.

impersonate_service_accountOptional

  • Type: str
(Optional) The service account to impersonate for accessing the State Bucket. You must have roles/iam.serviceAccountTokenCreator role on that account for the impersonation to succeed. If you are using a delegation chain, you can specify that using the impersonate_service_account_delegates field. Alternatively, this can be specified using the GOOGLE_IMPERSONATE_SERVICE_ACCOUNT environment variable.

impersonate_service_account_delegatesOptional

  • Type: typing.List[str]
(Optional) The delegation chain for an impersonating a service account.

kms_encryption_keyOptional

  • Type: str
(Optional) A Cloud KMS key (‘customer-managed encryption key’) used when reading and writing state files in the bucket. Format should be projects/{{project}}/locations/{{location}}/keyRings/{{keyRing}}/cryptoKeys/{{name}}. For more information, including IAM requirements, see Customer-managed Encryption Keys.

prefixOptional

  • Type: str
(Optional) GCS prefix inside the bucket. Named states for workspaces are stored in an object called < prefix >/< name >.tfstate.

storeage_custom_endpointOptional

  • Type: str
(Optional) A URL containing three parts: the protocol, the DNS name pointing to a Private Service Connect endpoint, and the path for the Cloud Storage API (/storage/v1/b). See here for more details

Methods


to_string

Returns a string representation of this construct.

with

Applies one or more mixins to this construct. Mixins are applied in order. The list of constructs is captured at the start of the call, so constructs added by a mixin will not be visited. Use multiple with() calls if subsequent mixins should apply to added constructs.

mixinsRequired

  • Type: *constructs.IMixin
The mixins to apply.

add_override

pathRequired

  • Type: str

valueRequired

  • Type: typing.Any

override_logical_id

Overrides the auto-generated logical ID with a specific ID.

new_logical_idRequired

  • Type: str
The new logical ID to use for this stack element.

reset_override_logical_id

Resets a previously passed logical Id to use the auto-generated logical id again.

to_hcl_terraform

Adds this resource to the terraform JSON output.

to_metadata

to_terraform

Adds this resource to the terraform JSON output.

get

outputRequired

  • Type: str

get_boolean

outputRequired

  • Type: str

get_list

outputRequired

  • Type: str

get_number

outputRequired

  • Type: str

get_string

outputRequired

  • Type: str

Static Functions


is_construct

Checks if x is a construct. Use this method instead of instanceof to properly detect Construct instances, even when the construct library is symlinked. Explanation: in JavaScript, multiple copies of the constructs library on disk are seen as independent, completely different libraries. As a consequence, the class Construct in each copy of the constructs library is seen as a different class, and an instance of one class will not test as instanceof the other class. npm install will not create installations like this, but users may manually symlink construct libraries together or use a monorepo tool: in those cases, multiple copies of the constructs library can be accidentally installed, and instanceof will behave unpredictably. It is safest to avoid using instanceof, and using this type-testing method instead.

xRequired

  • Type: typing.Any
Any object.

is_terraform_element

xRequired

  • Type: typing.Any

Properties


nodeRequired

  • Type: constructs.Node
The tree node.

cdktf_stackRequired


fqnRequired

  • Type: str

friendly_unique_idRequired

  • Type: str

Constants


tfResourceTypeRequired

  • Type: str